matrixSslOpen 						proto C
matrixSslClose      				proto C
matrixSslReadKeys 					proto C :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
matrixSslReadKeysMem 				proto C :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
matrixSslFreeKeys					proto C :DWORD,:DWORD
matrixSslNewSession					proto C :DWORD,:DWORD,:DWORD,:DWORD
matrixSslDeleteSession  			proto C :DWORD
matrixSslDecode						proto C :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
matrixSslEncode						proto C :DWORD,:DWORD,:DWORD,:DWORD
matrixSslEncodeClosureAlert			proto C :DWORD,:DWORD
matrixSslHandshakeIsComplete		proto C :DWORD
matrixSslSetCertValidator			proto C :DWORD,:DWORD,:DWORD,:DWORD
matrixSslSetSessionOption			proto C :DWORD,:DWORD,:DWORD
matrixSslGetAnonStatus				proto C :DWORD,:DWORD
matrixSslAssignNewKeys				proto C :DWORD,:DWORD

comment !
	Client side APIs
!
matrixSslEncodeClientHello			proto C :DWORD,:DWORD,:DWORD
matrixSslGetSessionId				proto C :DWORD,:DWORD
matrixSslFreeSessionId				proto C :DWORD

comment !
	Server side APIs
!
matrixSslEncodeHelloRequest			proto C :DWORD,:DWORD
matrixSslSetResumptionFlag			proto C :DWORD,:DWORD
matrixSslGetResumptionFlag			proto C :DWORD,:DWORD


SSL_MAX_PLAINTEXT_LEN			equ		4000h	;16KB 
SSL_MAX_RECORD_LEN				equ		SSL_MAX_PLAINTEXT_LEN + 2048
SSL_MAX_BUF_SIZE				equ		SSL_MAX_RECORD_LEN + 5h

comment !
	Return codes from public apis
	Not all apis return all codes.  See documentation for more details.
!
SSL_SUCCESS						equ 0	; Generic success 
SSL_ERROR						equ -1	; generic ssl error, see error code 
SSL_FULL						equ -2	; must call sslRead before decoding 
SSL_PARTIAL						equ -3	; more data reqired to parse full msg 
SSL_SEND_RESPONSE				equ -4	; decode produced output data 
SSL_PROCESS_DATA				equ -5	; succesfully decoded application data 
SSL_ALERT						equ -6	; we've decoded an alert 
SSL_FILE_NOT_FOUND				equ -7	; File not found 
SSL_MEM_ERROR					equ -8	; Memory allocation failure 

comment !
	SSL Alert levels and descriptions
	This implementation treats all alerts as fatal
!
SSL_ALERT_LEVEL_WARNING				equ	 1
SSL_ALERT_LEVEL_FATAL				equ	 2

SSL_ALERT_CLOSE_NOTIFY				equ	 0
SSL_ALERT_UNEXPECTED_MESSAGE		equ	 10
SSL_ALERT_BAD_RECORD_MAC			equ	 20
SSL_ALERT_DECOMPRESSION_FAILURE		equ	 30
SSL_ALERT_HANDSHAKE_FAILURE			equ  40
SSL_ALERT_NO_CERTIFICATE			equ  41
SSL_ALERT_BAD_CERTIFICATE			equ  42
SSL_ALERT_UNSUPPORTED_CERTIFICATE	equ  43
SSL_ALERT_CERTIFICATE_REVOKED		equ  44
SSL_ALERT_CERTIFICATE_EXPIRED		equ  45
SSL_ALERT_CERTIFICATE_UNKNOWN		equ  46
SSL_ALERT_ILLEGAL_PARAMETER			equ  47

comment !
	Use as return code in user validation callback to allow
	anonymous connections to proceed
!
SSL_ALLOW_ANON_CONNECTION			equ	 67


comment !
	Flags for matrixSslNewSession
!
SSL_FLAGS_SERVER					equ 1h
SSL_FLAGS_CLIENT_AUTH				equ 200h

SSL_OPTION_DELETE_SESSION			equ 0

ssl_t   		DWORD ?
sslKeys_t    	DWORD ?
sslSessionId_t  DWORD ?
sslRsaCert_t	DWORD ?


sslBuf_t struct 
	ibuf 	DWORD ?	; Pointer to the start of the buffer */
	istart 	DWORD ?	; Pointer to start of valid data */
	iend	DWORD ?	; Pointer to first byte of invalid data */
	isize	DWORD ?	; Size of buffer in bytes */
sslBuf_t ends

sslDistinguishedName_t struct 
	country 		DWORD      ?
	state			DWORD      ?
	locality		DWORD      ?
	organization	DWORD      ?
	orgUnit			DWORD      ?
	commonName		DWORD      ?
sslDistinguishedName_t ends

sslSubjectAltName_t struct
	dns				DWORD      ?
	uri				DWORD      ?
	email			DWORD      ?
sslSubjectAltName_t ends

sslCertInfo2 struct
	verified 				DWORD ?
	serialNumber    		DWORD ?
	serialNumberLen  		DWORD ?
	notBefore  				DWORD ?
	notAfter   				DWORD ?
	sigHash    				DWORD ?
	sigHashLen  			DWORD ?
	subjectAltName 			sslSubjectAltName_t    <?,?,?>
	subject					sslDistinguishedName_t <?,?,?,?,?,?>
	issuer					sslDistinguishedName_t <?,?,?,?,?,?>
sslCertInfo2 ends

sslCertInfo struct
	verified 				DWORD ?
	serialNumber    		DWORD ?
	serialNumberLen  		DWORD ?
	notBefore  				DWORD ?
	notAfter   				DWORD ?
	sigHash    				DWORD ?
	sigHashLen  			DWORD ?
	subjectAltName 			sslSubjectAltName_t    <?,?,?>
	subject					sslDistinguishedName_t <?,?,?,?,?,?>
	issuer					sslDistinguishedName_t <?,?,?,?,?,?>
	inext 					sslCertInfo2 <?>
sslCertInfo ends

sslConn_t struct
	ssl					DWORD ?
	inbuf				sslBuf_t <?>
	insock				sslBuf_t <?>
	outsock				sslBuf_t <?>
	outBufferCount		DWORD ?
	fd					DWORD ?
sslConn_t ends
